﻿using System;
using System.Windows.Forms;
using System.Numerics;

namespace permittivity
{
    public partial class UserControl1 : UserControl
    {
        public MainWindow UC;
        public UserControl1()
        {
            InitializeComponent();
        }

        public void SetUC()
        {
            int N = Convert.ToInt32(UC.TextBox1.Text);
            dataGridView1.RowCount = 9*N+3;
            dataGridView1.Rows[0].Cells[0].Value = "記号";
            dataGridView1.Rows[0].Cells[1].Value = "ｆ";
            dataGridView1.Rows[0].Cells[2].Value = "εr";
            dataGridView1.Rows[0].Cells[3].Value = "εi";
            dataGridView1.Rows[0].Cells[4].Value = "Nr";
            dataGridView1.Rows[0].Cells[5].Value = "Ni";
            dataGridView1.Rows[0].Cells[6].Value = "R";

            dataGridView1.Rows[1].Cells[0].Value = "単位";
            dataGridView1.Rows[1].Cells[1].Value = "Hz";
            dataGridView1.Rows[1].Cells[2].Value = "相対";
            dataGridView1.Rows[1].Cells[3].Value = "相対";
            dataGridView1.Rows[1].Cells[4].Value = "無次元";
            dataGridView1.Rows[1].Cells[5].Value = "無次元";
            dataGridView1.Rows[1].Cells[6].Value = "無次元";

            int i;
            for (i = 0; i < 9*N; i++) { dataGridView1.Rows[2 + i].Cells[0].Value = Convert.ToString(i + 1); }
        }

        public void CalExe()
        {
            double f; double df;
            int N = Convert.ToInt32(UC.TextBox1.Text);
            df = Math.Pow(10, 1.0 / N);
          
            double Epsr; double Epsi;
            Complex Eps;

            int i;
            f = 1000;
            for (i = 0; i < 9 * N; i++) 
            {
                
                dataGridView1.Rows[2 + i].Cells[1].Value = Convert.ToString(f);


                if (f < 5500000)
                {
                    Epsr = 76.47; Epsi = 98225 / f;
                    Eps = new Complex(Epsr, Epsi);
                }
                else
                {
                    Complex A = new Complex(1, f / 22000000000);
                    Complex B = new Complex(71.57, 0);
                    Complex C = new Complex( 4.9, 0);
                    Complex D = Complex.Divide(B, A);
                    Eps = Complex.Add(C, D);
                    Epsr = Eps.Real; Epsi =Eps.Imaginary;
                }
                dataGridView1.Rows[2 + i].Cells[2].Value = Convert.ToString(Epsr);
                dataGridView1.Rows[2 + i].Cells[3].Value = Convert.ToString(Epsi);


                Complex n = Complex.Sqrt(Eps);
                dataGridView1.Rows[2 + i].Cells[4].Value = Convert.ToString(n.Real);
                dataGridView1.Rows[2 + i].Cells[5].Value = Convert.ToString(n.Imaginary);


                Complex A1 = new Complex(1, 0);
                Complex B1 = Complex.Add(A1, n);
                Complex C1 = Complex.Subtract(A1, n);
                Complex r = Complex.Divide(C1, B1);

                double R = (r.Magnitude) * (r.Magnitude);
                dataGridView1.Rows[2 + i].Cells[6].Value = Convert.ToString(R);

                f = f *df;
            }
        }
    }
}
